searchNodes=[{"doc":"Making the IEx console friendlier one command at a time To use the helpers, run: iex&gt; use Toolshed Add this to your .iex.exs to load automatically. The following is a list of helpers: cat/1 - print out a file cmd/1 - run a system command and print the output date/0 - print out the current date and time dmesg/0 - print kernel messages (Nerves-only) exit/0 - exit out of an IEx session fw_validate/0 - marks the current image as valid (check Nerves system if supported) grep/2 - print out lines that match a regular expression hex/1 - print a number as hex hostname/0 - print our hostname ifconfig/0 - print info on network interfaces load_term!/2 - load a term that was saved by save_term/2 lsof/0 - print out open file handles by OS process lsmod/0 - print out what kernel modules have been loaded (Nerves-only) lsusb/0 - print info on USB devices multicast_addresses/0 - print out all multicast addresses nslookup/1 - query DNS to find an IP address pastebin/1 - post text to a pastebin server (requires networking) ping/2 - ping a remote host (but use TCP instead of ICMP) qr_encode/1 - create a QR code (requires networking) reboot/0 - reboots gracefully (Nerves-only) reboot!/0 - reboots immediately (Nerves-only) save_value/2 - save a value to a file as Elixir terms (uses inspect) save_term!/2 - save a term as a binary top/2 - list out the top processes tping/2 - check if a host can be reached (like ping, but uses TCP) tree/1 - pretty print a directory tree uptime/0 - print out the current Erlang VM uptime uname/0 - print information about the running system (Nerves-only) weather/0 - get the local weather (requires networking)","ref":"Toolshed.html","title":"Toolshed","type":"module"},{"doc":"Run a command and return the exit code. This function is intended to be run interactively.","ref":"Toolshed.html#cmd/1","title":"Toolshed.cmd/1","type":"function"},{"doc":"Inspect a value with all integers printed out in hex. This is useful for one-off hex conversions. If you&#39;re doing a lot of work that requires hexadecimal output, you should consider running: IEx.configure(inspect: [base: :hex]) The drawback of doing the above is that strings print out as hex binaries.","ref":"Toolshed.html#hex/1","title":"Toolshed.hex/1","type":"function"},{"doc":"Helpers that make HTTP requests","ref":"Toolshed.HTTP.html","title":"Toolshed.HTTP","type":"module"},{"doc":"Post text to a paste service This is a convenient way of sharing text data with others. It currently posts to &quot;exbin.call-cc.be&quot;. Keep in mind that the text is posted in the clear and the server may retain it indefinitely. On success, this function returns a URL to the posted text.","ref":"Toolshed.HTTP.html#pastebin/1","title":"Toolshed.HTTP.pastebin/1","type":"function"},{"doc":"Generate an ASCII art QR code See https://github.com/chubin/qrenco.de for more information.","ref":"Toolshed.HTTP.html#qr_encode/1","title":"Toolshed.HTTP.qr_encode/1","type":"function"},{"doc":"Display the local weather See http://wttr.in/:help for more information.","ref":"Toolshed.HTTP.html#weather/0","title":"Toolshed.HTTP.weather/0","type":"function"},{"doc":"Helpers that are useful for querying hardware information. These are Linux/Nerves-specific. Helpers include: lsusb/0 - print out connected USB devices","ref":"Toolshed.HW.html","title":"Toolshed.HW","type":"module"},{"doc":"Print out information on all of the connected USB devices.","ref":"Toolshed.HW.html#lsusb/0","title":"Toolshed.HW.lsusb/0","type":"function"},{"doc":"List out open files by process","ref":"Toolshed.Lsof.html","title":"Toolshed.Lsof","type":"module"},{"doc":"List out open files by process This is an simple version of lsof that works on Linux and Nerves. While running the normal version of lsof provides more information, this can be convenient when lsof isn&#39;t easily available or can&#39;t be run due to :emfile errors from starting port processes due to too many files being open..","ref":"Toolshed.Lsof.html#lsof/0","title":"Toolshed.Lsof.lsof/0","type":"function"},{"doc":"Miscellaneous helpers","ref":"Toolshed.Misc.html","title":"Toolshed.Misc","type":"module"},{"doc":"Exit the current IEx session","ref":"Toolshed.Misc.html#exit/0","title":"Toolshed.Misc.exit/0","type":"function"},{"doc":"Load an Erlang term from the filesystem. Examples # iex&gt; save_term!({:some_interesting_atom, [&quot;some&quot;, &quot;list&quot;]}, &quot;/root/some_atom.term&quot;) {:some_interesting_atom, [&quot;some&quot;, &quot;list&quot;]} iex&gt; load_term!(&quot;/root/some_atom.term&quot;) {:some_interesting_atom, [&quot;some&quot;, &quot;list&quot;]}","ref":"Toolshed.Misc.html#load_term!/1","title":"Toolshed.Misc.load_term!/1","type":"function"},{"doc":"Save an Erlang term to the filesystem for easy loading later This function returns the value passed in to allow easy piping. Examples # iex&gt; :sys.get_state(MyServer) |&gt; save_term!(&quot;/root/my_server.term&quot;) # Reboot board iex&gt; :sys.replace_state(&amp;load_term!(&quot;/root/my_server.term&quot;))","ref":"Toolshed.Misc.html#save_term!/2","title":"Toolshed.Misc.save_term!/2","type":"function"},{"doc":"Save a value to a file as Elixir terms Examples # Save the contents of SystemRegistry to a file iex&gt; SystemRegistry.match(:_) |&gt; save_value(&quot;/root/sr.txt&quot;) :ok","ref":"Toolshed.Misc.html#save_value/3","title":"Toolshed.Misc.save_value/3","type":"function"},{"doc":"Multicast utilities","ref":"Toolshed.Multicast.html","title":"Toolshed.Multicast","type":"module"},{"doc":"List all active multicast addresses This lists out multicast addresses by network interface similar to ip maddr show. It currently only works on Linux.","ref":"Toolshed.Multicast.html#multicast_addresses/0","title":"Toolshed.Multicast.multicast_addresses/0","type":"function"},{"doc":"Helper for processing the multicast subscription information files","ref":"Toolshed.Multicast.html#process_proc/3","title":"Toolshed.Multicast.process_proc/3","type":"function"},{"doc":"Helpers that are useful on Nerves devices Helpers include: dmesg/0 - print kernel messages fw_validate/0 - marks the current image as valid (check Nerves system if supported) lsmod/0 - print out what kernel modules have been loaded reboot/0 - reboots gracefully reboot!/0 - reboots immediately uname/0 - print information about the running system","ref":"Toolshed.Nerves.html","title":"Toolshed.Nerves","type":"module"},{"doc":"Print out kernel log messages","ref":"Toolshed.Nerves.html#dmesg/0","title":"Toolshed.Nerves.dmesg/0","type":"function"},{"doc":"Validate a firmware image All official Nerves Systems automatically validate newly installed firmware. For some systems, it&#39;s possible to disable this so that new firmware gets one chance to boot. If it&#39;s not &quot;validated&quot; before a reboot, then the device reverts to the old firmware.","ref":"Toolshed.Nerves.html#fw_validate/0","title":"Toolshed.Nerves.fw_validate/0","type":"function"},{"doc":"Print out the loaded kernel modules Aside from printing out whether the kernel has been tainted, the Linux utility of the same name just dump the contents of &quot;/proc/modules&quot; like this one. Some kernel modules may be built-in to the kernel image. To see those, run cat &quot;/lib/modules/x.y.z/modules.builtin&quot; where x.y.z is the kernel&#39;s version number.","ref":"Toolshed.Nerves.html#lsmod/0","title":"Toolshed.Nerves.lsmod/0","type":"function"},{"doc":"Shortcut to reboot a board. This is a graceful reboot, so it takes some time before the real reboot.","ref":"Toolshed.Nerves.html#reboot/0","title":"Toolshed.Nerves.reboot/0","type":"function"},{"doc":"Reboot immediately without a graceful shutdown. This is for the impatient.","ref":"Toolshed.Nerves.html#reboot!/0","title":"Toolshed.Nerves.reboot!/0","type":"function"},{"doc":"Print out information about the running software This is similar to the Linux uname to help people remember what to type.","ref":"Toolshed.Nerves.html#uname/0","title":"Toolshed.Nerves.uname/0","type":"function"},{"doc":"Network related helpers","ref":"Toolshed.Net.html","title":"Toolshed.Net","type":"module"},{"doc":"","ref":"Toolshed.Net.html#hostent/2","title":"Toolshed.Net.hostent/2","type":"macro"},{"doc":"Return the hostname Examples iex&gt; hostname &quot;nerves-1234&quot;","ref":"Toolshed.Net.html#hostname/0","title":"Toolshed.Net.hostname/0","type":"function"},{"doc":"Print out the network interfaces and their addresses.","ref":"Toolshed.Net.html#ifconfig/0","title":"Toolshed.Net.ifconfig/0","type":"function"},{"doc":"Lookup the specified hostname in the DNS and print out the addresses. Examples iex&gt; nslookup &quot;google.com&quot; Name: google.com Address: 172.217.7.238 Address: 2607:f8b0:4004:804::200e","ref":"Toolshed.Net.html#nslookup/1","title":"Toolshed.Net.nslookup/1","type":"function"},{"doc":"Ping an IP address using TCP This tries to connect to the remote host using TCP instead of sending an ICMP echo request like normal ping. This made it possible to write in pure Elixir. NOTE: Specifying an :ifname only sets the source IP address for the TCP connection. This is only a hint to use the specified interface and not a guarantee. For example, if you have two interfaces on the same LAN, the OS routing tables may send traffic out one interface in preference to the one that you want. On Linux, you can enable policy-based routing and add source routes to guarantee that packets go out the desired interface. Options: :ifname - Specify a network interface to use. (e.g., &quot;eth0&quot;) Examples iex&gt; ping &quot;nerves-project.org&quot; Press enter to stop Response from nerves-project.org (185.199.108.153): time=4.155ms Response from nerves-project.org (185.199.108.153): time=10.385ms Response from nerves-project.org (185.199.108.153): time=12.458ms iex&gt; ping &quot;google.com&quot;, ifname: &quot;wlp5s0&quot; Press enter to stop Response from google.com (172.217.7.206): time=88.602ms","ref":"Toolshed.Net.html#ping/2","title":"Toolshed.Net.ping/2","type":"function"},{"doc":"Check if a computer is up using TCP. Options: :ifname - Specify a network interface to use. (e.g., &quot;eth0&quot;) Examples iex&gt; tping &quot;nerves-project.org&quot; Response from nerves-project.org (185.199.108.153): time=4.155ms iex&gt; tping &quot;192.168.1.1&quot; Response from 192.168.1.1 (192.168.1.1): time=1.227ms","ref":"Toolshed.Net.html#tping/2","title":"Toolshed.Net.tping/2","type":"function"},{"doc":"Find the top processes","ref":"Toolshed.Top.html","title":"Toolshed.Top","type":"module"},{"doc":"List the top processes Options: :order - the sort order for the results (:reductions, :delta_reductions, :mailbox, :delta_mailbox, :total_heap_size, :delta_total_heap_size, :heap_size, :delta_heap_size, :stack_size, :delta_stack_size) :n - the max number of processes to list","ref":"Toolshed.Top.html#top/1","title":"Toolshed.Top.top/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_heap_size/1","title":"Toolshed.Top.top_heap_size/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_mailbox/1","title":"Toolshed.Top.top_mailbox/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_reductions/1","title":"Toolshed.Top.top_reductions/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_stack_size/1","title":"Toolshed.Top.top_stack_size/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_total_heap_size/1","title":"Toolshed.Top.top_total_heap_size/1","type":"function"},{"doc":"Helpers for when your fingers are too used to typing Unix commands. Helpers include: cat/1 - print out a file date/0 - print out the current date and time grep/2 - print out lines of a file that match a regular expression tree/1 - print out a directory tree uptime/0 - print the update of the Erlang VM","ref":"Toolshed.Unix.html","title":"Toolshed.Unix","type":"module"},{"doc":"Print out a file","ref":"Toolshed.Unix.html#cat/1","title":"Toolshed.Unix.cat/1","type":"function"},{"doc":"Print out the date similar to the Unix date command","ref":"Toolshed.Unix.html#date/0","title":"Toolshed.Unix.date/0","type":"function"},{"doc":"Run a regular expression on a file and print the matching lines. iex&gt; grep ~r/video/, &quot;/etc/mime.types&quot;","ref":"Toolshed.Unix.html#grep/2","title":"Toolshed.Unix.grep/2","type":"function"},{"doc":"Print out directories and files in tree form.","ref":"Toolshed.Unix.html#tree/1","title":"Toolshed.Unix.tree/1","type":"function"},{"doc":"Print out the current uptime.","ref":"Toolshed.Unix.html#uptime/0","title":"Toolshed.Unix.uptime/0","type":"function"},{"doc":"Toolshed This package adds a number of commands to the IEx prompt to make working at the console more enjoyable. It&#39;s an experiment in aggregating code snippets from projects into one place. Some utilities merely wrap Erlang functions that are hard to remember and some actually do quite a bit of work. Please make my helpers your helpers too and send some back. Here&#39;s a sample of what you&#39;ll get: cmd - run a command and print out the output top - get a list of the top processes and their OTP applications based on CPU and memory exit - exit an IEx session (useful over ssh) tree - list directory contents as a tree save_term/load_term - save and load Elixir terms to files tping - check if a remote host is up (like ping, but uses TCP) ifconfig - list network interfaces lsusb - list USB devices To get a complete list: iex&gt; h Toolshed To try it out, add this project to your deps: def deps do [ {:toolshed, &quot;~&gt; 0.2&quot;} ] end Rebuild and run in whatever way you prefer. At the IEx prompt, run: iex&gt; use Toolshed Toolshed imported. Run h(Toolshed) for more info. :ok iex&gt; cmd(&quot;echo hello world&quot;) hello world 0 iex&gt; Toolshed.Net.ping &quot;nerves-project.org&quot; Press enter to stop Response from nerves-project.org (185.199.108.153): time=4.155ms Response from nerves-project.org (185.199.108.153): time=10.385ms Response from nerves-project.org (185.199.108.153): time=12.458ms iex&gt; top OTP Application Name or PID Reds/Δ Mbox/Δ Total/Δ Heap/Δ Stack/Δ nerves_runtime Nerves.Runtime.Kernel.UE 72M/10M 157/-32 384K/-4642 192K/73K 86/52 system_registry SystemRegistry.Global 41M/6134K 0/0 694K/192K 192K/0 35/-11 system_registry SystemRegistry.Processor 61M/6075K 0/0 73K/-1215 73K/0 10/0 system_registry SystemRegistry.Registrat 1623K/293K 1/1 211K/109K 73K/0 10/0 system_registry SystemRegistry.Processor 790K/197K 59/3 1011K/4461 502K/0 38/0 undefined #PID&lt;0.1793.0&gt; 221K/68K 0/0 21K/0 6772/0 504/0 system_registry SystemRegistry.Processor 382K/58K 0/0 16K/-1227 4185/-1354 22/0 ssh #PID&lt;0.1786.0&gt; 133K/52K 0/0 4184/1599 2586/1599 10/0 nerves_init_gadg #PID&lt;0.1432.0&gt; 213K/39K 0/0 192K/101K 73K/0 10/0 When you get tired of typing use Toolshed, add it to your .iex.exs.","ref":"readme.html","title":"Toolshed","type":"extras"},{"doc":"I have some IEx helpers. Would you consider adding them? Yes! Absolutely. Please send a PR. At some point I may have to whittle down what&#39;s in the library, but for now, I&#39;m open to adding almost anything. This includes: Pretty much anything that helps debugging or inspecting a running system Wrappers on OTP functions that are hard to remember or have output that&#39;s not ideal for interactive use. Fun stuff - submit a text game if it&#39;s not too long if you&#39;d like. I&#39;d really like to stay away from adding anything that&#39;s not Elixir to this project. I.e., no port processes or NIFs. It would also be nice to keep Toolshed low on dependencies. Of course, maybe I&#39;m just not thinking of something. Don&#39;t let that be a reason to not file an issue proposing the idea. If it doesn&#39;t seem to fit well, maybe a simplified version does and we add a link to the full featured one. A lot of these look like Unix commands? Why not run a proper shell? Yeah, I miss many Unix commands when I&#39;m at the IEx prompt. Switching to a shell is easy on my laptop, but on Nerves devices, it&#39;s a pain. Getting a shell prompt on Nerves is possible, but it&#39;s limited due to Nerves not containing a full set of commands and it having to be run through Erlang&#39;s job control. Not having file name tab completion is painful. That&#39;s not a question, but yes. If you have ideas on how to fix, please tell! You can do so much more with some of these helpers!!! Definitely. There&#39;s so much that I&#39;d like to explore, but time gets in the way. I&#39;m not sold on many decisions that I made, but something was better than nothing. Please help me improve this or make your own IEx helpers library. I&#39;m quite happy to use it too or pull it in as a dependency. I want to use one of the functions in my program. Is the API stable? This really isn&#39;t a normal hex.pm library. Use it for the helpers. If you want some code, copy and paste it or incorporate it into a library. I&#39;d like the flexibility to change the API to improve interactive use. It would be better if you changed the colors. This also isn&#39;t a question, and you&#39;ve now made me regret naming the project toolshed. Please file your grievances here.","ref":"readme.html#faq","title":"Toolshed - FAQ","type":"extras"}]